from collections.abc import Callable

from simudator.core.breakpoint import Breakpoint


class LambdaBreakpoint(Breakpoint):
    def __init__(self, lambda_func: Callable[..., bool], **kwargs) -> None:
        super().__init__()
        self.lambda_func = lambda_func
        self.kwargs = kwargs

    def is_break(self):
        return self.lambda_func(**self.kwargs)

    def __str__(self) -> str:
        s = f"Lambda {self.lambda_func.__name__} with kwargs {self.kwargs}"
        return s
