from typing import Any

from simudator.core.breakpoint import Breakpoint
from simudator.core.modules import Memory


class MemoryBreakpoint(Breakpoint):
    def __init__(self, memory: Memory, adress: int, value: Any) -> None:
        super().__init__()
        self.memory = memory
        self.adress = adress
        self.value = value

    def is_break(self):
        memory_content = self.memory.get_state()["memory"]
        return memory_content[self.adress] == self.value

    def __str__(self) -> str:
        return f"{self.memory.name} {self.adress}: {self.value}"
