from simudator.gui.module_graphics_item.register_graphic import (
    IntegerRegisterGraphicsItem,
)
from simudator.gui.orientation import Orientation
from simudator.gui.port_graphics_item import PortGraphicsItem


class ArGraphicsItem(IntegerRegisterGraphicsItem):
    """
    Graphics item for mias AR register
    """

    def draw_graphics_item(self):
        self.draw_rect()

        width = (
            len(self.text.text()) * self._RECT_WIDTH_PER_CHAR + self._TEXT_WIDTH_MARGIN
        )

        # Draw bus port
        bus_port = PortGraphicsItem(self.module.output_s, parent=self)
        bus_port.setPos(width, self._RECT_HEIGHT / 2)
        self.ports.append(bus_port)

        # Draw to alu port
        to_alu_port = PortGraphicsItem(
            self.module.alu_output_signal, Orientation.LEFT, parent=self
        )
        to_alu_port.setPos(0, self._RECT_HEIGHT / 2)
        self.ports.append(to_alu_port)

        # Draw from alu port
        from_alu_port = PortGraphicsItem(
            self.module.input_s, Orientation.UP, parent=self
        )
        from_alu_port.setPos(width / 2, 0)
        self.ports.append(from_alu_port)
