from simudator.gui.module_graphics_item.register_graphic import (
    IntegerRegisterGraphicsItem,
)
from simudator.gui.orientation import Orientation
from simudator.gui.port_graphics_item import PortGraphicsItem


class AsrGraphicsItem(IntegerRegisterGraphicsItem):
    """
    Graphics item for mias ASR module.
    """

    def draw_graphics_item(self):
        # Draw register rect
        self.draw_rect()

        width = (
            len(self.text.text()) * self._RECT_WIDTH_PER_CHAR + self._TEXT_WIDTH_MARGIN
        )

        # Draw bus port
        bus_port = PortGraphicsItem(self.module.input_s, parent=self)
        bus_port.setPos(width, self._RECT_HEIGHT / 2)
        self.ports.append(bus_port)

        # Draw to memory port
        to_memory_port = PortGraphicsItem(
            self.module.output_s, Orientation.LEFT, parent=self
        )
        to_memory_port.setPos(0, self._RECT_HEIGHT / 2)
        self.ports.append(to_memory_port)
